package com.lombardisoftware.gwtcommon.client;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.ComplexPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author tcarpenter
 * @created Jan 9, 2008, 4:03:39 PM
 */
public class HeadingPanel extends ComplexPanel {


    public HeadingPanel() {
        this(1);
    }

    public HeadingPanel(int level) {
        super();
        if (level < 1 || level > 6) {
            throw new UnsupportedOperationException("Unsupported heading level. Use 1-6.");
        }
        setElement(DOM.createElement("h" + level));
    }

    public void add(Widget child) {
        super.add(child, getElement());
    }

    public void addText(String text) {
        Span span = new Span();
        CommonUtils.addAutomationId(span, "gwtcommon.client.headingPanel.span_0");
        span.setText(text);
        add(span);
    }

    public void insert(Widget child, int index) {
        super.insert(child, getElement(), index, true);
    }

}
