/**
 * Copyright (C) 2006 Lombardi Software
 * http://www.lombardi.com/
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of Lombardi
 * Software ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement and/or Non-Disclosure Agreement you entered into
 * with Lombardi Software. No rights are licenses are granted with respect to
 * the Confidential Information except as expressly set forth in such License
 * Agreement and/or Non-Disclosure Agreement.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL LOMBARDI
 * SOFTWARE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * @author bcampbell
 * @date: Apr 7, 2008
 */
package com.lombardisoftware.gwtcommon.client.clientObjects;

import java.util.List;
import java.io.Serializable;


public class ClientProcessAppDeployment extends AbstractClientObject implements Serializable {

    private String projectId;
    private long projectLastModified;
    private Long projectLastModifiedByUserId;
    private String projectLastModifiedByUserName;
    private String projectName;
    private String projectShortName;
    private boolean isToolkit;

    private List<ClientDeployedSnapshot> deployments;
    
    public ClientProcessAppDeployment() {
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public long getProjectLastModified() {
        return projectLastModified;
    }

    public void setProjectLastModified(long projectLastModified) {
        this.projectLastModified = projectLastModified;
    }

    public Long getProjectLastModifiedByUserId() {
        return projectLastModifiedByUserId;
    }

    public void setProjectLastModifiedByUserId(Long projectLastModifiedByUserId) {
        this.projectLastModifiedByUserId = projectLastModifiedByUserId;
    }

    public String getProjectLastModifiedByUserName() {
        return projectLastModifiedByUserName;
    }

    public void setProjectLastModifiedByUserName(String projectLastModifiedByUserName) {
        this.projectLastModifiedByUserName = projectLastModifiedByUserName;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getProjectShortName() {
        return projectShortName;
    }

    public void setProjectShortName(String projectShortName) {
        this.projectShortName = projectShortName;
    }

    public List<ClientDeployedSnapshot> getDeployments() {
        return deployments;
    }

    public void setDeployments(List<ClientDeployedSnapshot> deployments) {
        this.deployments = deployments;
    }

    public String getId() {
        return projectId;
    }

    public boolean isToolkit() {
        return isToolkit;
    }
    
    public void setToolkit(boolean isToolkit) {
        this.isToolkit = isToolkit;
    }
}
