/**
 * 
 */
package com.lombardisoftware.gwtcommon.client.clientObjects;

import java.io.Serializable;

/**
 * Marks client objects which can be favorited.
 * 
 * @author jsugg
 */
public interface Favoritable extends Serializable {

    // we include getId in this interface because the ID is necessary to mark something as a favorite
    public String getId();
    
    // check whether an object has been marked as a favorite
    public boolean isFavorite();
    
    // mark or unmark an object as a favorite -- note that this assumes some enclosing context that
    // defines what user this object is a favorite for.
    public void setFavorite(boolean favorite);
}
