<?xml version="1.0" encoding="UTF-8"?>
<!--
 (C) Lombardi Software 2008, All Rights Reserved	
 This file is a part of the Teamworks products suite
-->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:wsdd="http://xml.apache.org/axis/wsdd/"
	xmlns:webapi="http://webapi.lombardisoftware.com">
	
<xsl:output method="xml" indent="yes"/>

<!--
 Copy everything that has no other pattern defined
 -->
<xsl:template match="*">
	<xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:apply-templates/>
	</xsl:copy>
</xsl:template>

<!--
 Process "wsdd:arrayMapping" entry and forcibly set "encodingStyle" attribute to "" (empty).
 This is required because "encodingStyle" attribute is lost after processing by Axis's "Admin" tool.
 As far as WebAPI doesn't use encoding we need to have all array mappings in the "" encoding namespace.
 -->
<xsl:template match="/wsdd:deployment/wsdd:service/wsdd:arrayMapping">
	<xsl:copy>
		<xsl:copy-of select="@*[local-name() != 'encodingStyle']"/>
		<xsl:attribute name="encodingStyle"><xsl:text></xsl:text></xsl:attribute>
	</xsl:copy>
</xsl:template>

</xsl:stylesheet>
