import sys

errorCode = ""
errorInfo = ""

# common operations useful for configuring jms things
execfile(installDir+"/bin/config_util.py" )
execfile(installDir+"/bin/config_server.py" )

#
# WMQ functions
#

def removeWMQQueueConnectionFactory ( jmsProvider, connectionFactoryName ):
        global AdminConfig

        existingConnectionFactories = AdminTask.listWMQConnectionFactories(cell, ["-type", "QCF"]).splitlines()
        for connectionFactory in existingConnectionFactories:
                fn = AdminConfig.showAttribute(connectionFactory, "name" )
                if (fn == connectionFactoryName):
                        print "Removing "+fn
                        AdminConfig.remove(connectionFactory )
                #endIf 
        #endFor 
#endDef 

def createWMQQueueConnectionFactory ( cell, connectionFactoryName, connectionFactoryJndiName, queueManagerName, host, port, channel ):
        global AdminTask

        print "Creating "+connectionFactoryName
        connectionFactory = AdminTask.createWMQConnectionFactory(cell, ["-name", connectionFactoryName, "-jndiName", connectionFactoryJndiName, "-type", "QCF", "-qmgrName", queueManagerName, "-wmqTransportType", "CLIENT", "-qmgrHostname", host, "-qmgrPortNumber", port, "-qmgrSvrconnChannel", channel])
        return connectionFactory
#endDef 

def removeWMQQueue ( cell, queueName ):
        global AdminConfig

        existingQueues = AdminTask.listWMQQueues(cell).splitlines()
        for queue in existingQueues:
                qn = AdminConfig.showAttribute(queue, "name" )
                if (qn == queueName):
                        print "Removing "+qn
                        AdminConfig.remove(queue )
                #endIf 
        #endFor 
#endDef 

def createWMQQueue ( cell, queueName, queueJndiName, queueManagerName):
        global AdminConfig

        print "Creating "+queueName
        queue = AdminTask.createWMQQueue(cell, ["-name", queueName, "-jndiName", queueJndiName, "-queueName", "TEAMWORKS_"+queueName.upper(), "-qmgr", queueManagerName, "-persistence", "PERS", "-priority", "APP", "-expiry", 0, "-useNativeEncoding", "false", "-integerEncoding", "Normal", "-decimalEncoding", "Normal", "-floatingPointEncoding", "IEEENormal"])
        print "Make sure you have defined a queue called "+AdminConfig.showAttribute(queue, "baseQueueName")+" in the queue manager "+queueManagerName
        return queue
#endDef 

def removeWMQTopicConnectionFactory ( cell, connectionFactoryName ):
        global AdminConfig

        existingConnectionFactories = AdminTask.listWMQConnectionFactories(cell, ["-type", "TCF"]).splitlines()
        for connectionFactory in existingConnectionFactories:
                fn = AdminConfig.showAttribute(connectionFactory, "name" )
                if (fn == connectionFactoryName):
                        print "Removing "+fn
                        AdminConfig.remove(connectionFactory )
                #endIf 
        #endFor 
#endDef 

def createWMQTopicConnectionFactory ( cell, connectionFactoryName, connectionFactoryJndiName, queueManagerName, host, port, channel, xaEnabled):
        global AdminConfig

        print "Creating "+connectionFactoryName
        connectionFactory = AdminTask.createWMQConnectionFactory(cell, ["-name", connectionFactoryName, "-jndiName", connectionFactoryJndiName, "-type", "TCF", "-qmgrName", queueManagerName, "-brokerQmgr", queueManagerName, "-wmqTransportType", "CLIENT", "-qmgrHostname", host, "-qmgrPortNumber", port, "-qmgrSvrconnChannel", channel, "-msgSelection", "CLIENT", "-support2PCProtocol", xaEnabled, "-clientId", connectionFactoryName])
        return connectionFactory
#endDef 

def createWMQActivationSpecification ( cell, activationSpecificationName, activationSpecificationJndiName, destinationJndiName, destinationType, queueManagerName, host, port, channel, authAlias ):
        global AdminTask

        print "Creating WMQ Activation Specification "+activationSpecificationName
        activationSpecification = AdminTask.createWMQActivationSpec(cell, ["-name", activationSpecificationName, "-jndiName", activationSpecificationJndiName, "-destinationJndiName", destinationJndiName, "-destinationType", destinationType, "-qmgrName", queueManagerName, "-wmqTransportType", "CLIENT", "-qmgrHostname", host, "-qmgrPortNumber", port, "-qmgrSvrconnChannel", channel, "-authAlias", authAlias, "-alwaysActivateAllMDBs", "true"] )
        return activationSpecification
#endDef 

def removeWMQActivationSpecification ( cell, activationSpecificationName ):
        global AdminConfig
        global AdminTask

        existingActivationSpecifications = AdminTask.listWMQActivationSpecs(cell ).splitlines()
        for activationSpecification in existingActivationSpecifications:
                qn = AdminConfig.showAttribute(activationSpecification, "name" )
                if (qn == activationSpecificationName):
                        print "Removing WMQ Activation Specification "+qn
                        AdminTask.deleteWMQActivationSpec(activationSpecification )
                #endIf 
        #endFor 
#endDef 

def createWMQTopic ( cell, topicName, topicJndiName ):
        global AdminConfig

        print "Creating "+topicName
        topic = AdminTask.createWMQTopic(cell, ["-name", topicName, "-jndiName", topicJndiName, "-topicName", topicName, "-persistence", "PERS", "-priority", "APP", "-expiry", "APP", "-useNativeEncoding", "false", "-integerEncoding", "Normal", "-decimalEncoding", "Normal", "-floatingPointEncoding", "IEEENormal"])
        return topic
#endDef 

def removeWMQTopic ( cell, topicName ):
        global AdminConfig

        existingTopics = AdminTask.listWMQTopics(cell).splitlines()
        for topic in existingTopics:
                qn = AdminConfig.showAttribute(topic, "name" )
                if (qn == topicName):
                        print "Removing "+qn
                        AdminConfig.remove(topic )
                #endIf 
        #endFor 
#endDef 

#
# Default Messaging functions
#

def removeSIBJMSQueueConnectionFactory ( cell, connectionFactoryName ):
        global AdminConfig
        global AdminTask

        existingConnectionFactories = AdminTask.listSIBJMSConnectionFactories(cell, ["-type", "queue"] ).splitlines()
        for connectionFactory in existingConnectionFactories:
                fn = AdminConfig.showAttribute(connectionFactory, "name" )
                if (fn == connectionFactoryName):
                        print "Removing "+fn
                        AdminTask.deleteSIBJMSConnectionFactory(connectionFactory )
                #endIf 
        #endFor 
#endDef 

def createSIBJMSQueueConnectionFactory ( cell, connectionFactoryName, connectionFactoryJndiName, busName, endPoints ):
        global AdminTask

        print "Creating "+connectionFactoryName
        connectionFactory = AdminTask.createSIBJMSConnectionFactory(cell, ["-name", connectionFactoryName, "-jndiName", connectionFactoryJndiName, "-busName", busName, "-type", "queue", "-providerEndPoints", endPoints] )
        return connectionFactory
#endDef 

def removeSIBJMSQueue ( cell, queueName ):
        global AdminConfig
        global AdminTask

        existingQueues = AdminTask.listSIBJMSQueues(cell ).splitlines()
        for queue in existingQueues:
                qn = AdminConfig.showAttribute(queue, "name" )
                if (qn == queueName):
                        AdminTask.deleteSIBJMSQueue(queue )
                #endIf 
        #endFor 
#endDef 

def createSIBJMSQueue ( cell, queueName, queueJndiName, busName, destination ):
        global AdminTask

        print "Creating "+queueName
        queue = AdminTask.createSIBJMSQueue(cell, ["-name", queueName, "-jndiName", queueJndiName, "-busName", busName, "-queueName", destination] )
        return queue
#endDef 

def removeSIBJMSTopicConnectionFactory ( cell, connectionFactoryName ):
        global AdminConfig
        global AdminTask

        existingConnectionFactories = AdminTask.listSIBJMSConnectionFactories(cell, ["-type", "topic"] ).splitlines()
        for connectionFactory in existingConnectionFactories:
                fn = AdminConfig.showAttribute(connectionFactory, "name" )
                if (fn == connectionFactoryName):
                        print "Removing "+fn
                        AdminTask.deleteSIBJMSConnectionFactory(connectionFactory )
                #endIf 
        #endFor 
#endDef 

def createSIBJMSTopicConnectionFactory ( cell, connectionFactoryName, connectionFactoryJndiName, busName, endPoints ):
        global AdminTask

        print "Creating "+connectionFactoryName
        connectionFactory = AdminTask.createSIBJMSConnectionFactory(cell, ["-name", connectionFactoryName, "-jndiName", connectionFactoryJndiName, "-busName", busName, "-type", "topic", "-providerEndPoints", endPoints] )
        return connectionFactory
#endDef 

def removeSIBJMSTopic ( cell, topicName ):
        global AdminConfig
        global AdminTask

        existingTopics = AdminTask.listSIBJMSTopics(cell ).splitlines()
        for topic in existingTopics:
                qn = AdminConfig.showAttribute(topic, "name" )
                if (qn == topicName):
                        print "Removing "+qn
                        AdminTask.deleteSIBJMSTopic(topic )
                #endIf 
        #endFor 
#endDef 

def createSIBJMSTopic ( cell, topicName, topicJndiName, busName, destination ):
        global AdminTask

        print "Creating "+topicName
        topic = AdminTask.createSIBJMSTopic(cell, ["-name", topicName, "-jndiName", topicJndiName, "-busName", busName, "-topicSpace", destination] )
        return topic
#endDef 

def createSIBJMSActivationSpecification ( cell, activationSpecificationName, activationSpecificationJndiName, busName, destinationJndiName, destinationType ):
        global AdminTask

        print "Creating Default Messaging Activation Specification "+activationSpecificationName
        activationSpecification = AdminTask.createSIBJMSActivationSpec(cell, ["-name", activationSpecificationName, "-jndiName", activationSpecificationJndiName, "-destinationJndiName", destinationJndiName, "-busName", busName, "-destinationType", destinationType, "-alwaysActivateAllMDBs", "true"] )
        return activationSpecification
#endDef 

def removeSIBJMSActivationSpecification ( cell, activationSpecificationName ):
        global AdminConfig
        global AdminTask

        existingActivationSpecifications = AdminTask.listSIBJMSActivationSpecs(cell ).splitlines()
        for activationSpecification in existingActivationSpecifications:
                qn = AdminConfig.showAttribute(activationSpecification, "name" )
                if (qn == activationSpecificationName):
                        print "Removing Default Messaging Activation Specification "+qn
                        AdminTask.deleteSIBJMSActivationSpec(activationSpecification )
                #endIf 
        #endFor 
#endDef 

def createSIB ( sibName ):
        global AdminTask

        print "Creating SIB "+sibName
        sib = AdminTask.createSIBus(["-bus", sibName, "-secure", "FALSE"] )
        return sib
#endDef 

def removeSIB ( sibName ):
        global AdminTask

        # Wrap in catch as we don't check for existence first
        try:
                print "Removing SIB "+sibName
                AdminTask.deleteSIBus(["-bus", sibName] )
        except:
                print ""
        
        #endTry 
#endDef 

def addSIBMember ( sibName, nodeName, serverName, dsJndiName, dsSchema, authAlias ):
        global AdminConfig
        global AdminTask

        print "Adding SIB member "+nodeName+":"+serverName+" to SIB "+sibName
        AdminTask.addSIBusMember(["-bus", sibName, "-node", nodeName, "-server", serverName, "-dataStore", "-createDefaultDatasource", "false", "-datasourceJndiName", dsJndiName, "-schemaName", dsSchema, "-authAlias", authAlias] )
#endDef 

def addSIBClusterMember ( sibName, clusterName, dsJndiName, dsSchema, authAlias ):
        global AdminConfig
        global AdminTask

        print "Adding SIB cluster member "+clusterName+" to SIB "+sibName
        AdminTask.addSIBusMember(["-bus", sibName, "-cluster", clusterName, "-dataStore", "-createDefaultDatasource", "false", "-datasourceJndiName", dsJndiName, "-schemaName", dsSchema, "-authAlias", authAlias] )
#endDef 

def createTopicSIBDestination ( sibName, sibDestinationName ):
        global AdminTask

        print "Creating TopicSpace SIB Destination "+sibDestinationName
        sibDestination = AdminTask.createSIBDestination(["-bus", sibName, "-name", sibDestinationName, "-type", "TopicSpace"] )
        return sibDestination
#endDef 

def createQueueSIBDestination ( sibName, sibDestinationName, nodeName, serverName, exceptionDestination ):
        global AdminTask

        print "Creating Queue SIB Destination "+sibDestinationName
        if (exceptionDestination != ""):
                sibDestination = AdminTask.createSIBDestination(["-bus", sibName, "-name", sibDestinationName, "-type", "Queue", "-node", nodeName, "-server", serverName, "-exceptionDestination", exceptionDestination, "-maxFailedDeliveries", 3] )
        else:
                sibDestination = AdminTask.createSIBDestination(["-bus", sibName, "-name", sibDestinationName, "-type", "Queue", "-node", nodeName, "-server", serverName] )
        #endElse 
        return sibDestination
#endDef 

def createQueueSIBClusterDestination ( sibName, sibDestinationName, clusterName, exceptionDestination ):
        global AdminTask

        print "Creating Queue SIB Cluster Destination "+sibDestinationName
        if (exceptionDestination != ""):
                sibDestination = AdminTask.createSIBDestination(["-bus", sibName, "-name", sibDestinationName, "-type", "Queue", "-cluster", clusterName, "-exceptionDestination", exceptionDestination, "-maxFailedDeliveries", 3] )
        else:
                sibDestination = AdminTask.createSIBDestination(["-bus", sibName, "-name", sibDestinationName, "-type", "Queue", "-cluster", clusterName] )
        #endElse 
        return sibDestination
#endDef 

def removeSIBDestination ( sibName, sibDestinationName ):
        global AdminTask

        # Wrap in catch as we don't check for existence first
        try:
                print "Removing SIB Destination "+sibDestinationName
                AdminTask.deleteSIBDestination(["-bus", sibName, "-name", sibDestinationName] )
        except:
                print ""
                
        #endTry 
#endDef 

def createSIBClusterEngine ( sibName, clusterName, dsJndiName, dsSchema, authAlias):
        engine = AdminTask.createSIBEngine(["-bus", sibName, "-cluster", clusterName, "-dataStore", "-createDefaultDatasource", "false", "-createTables", "true", "-datasourceJndiName", dsJndiName, "-schemaName", dsSchema, "-authAlias", authAlias])
        return engine
#endDef 

def createSIBPolicy ( cellName, nodeName, serverName, messagingEngineName ):
        coreGroup = AdminConfig.getid("/Cell:"+cellName+"/CoreGroup:DefaultCoreGroup/" )

        policyName = serverName+"_node"
        # Check if policy already exists and if it does delete it
        policyId = AdminConfig.getid("/Cell:"+cellName+"/CoreGroup:DefaultCoreGroup/OneOfNPolicy:"+policyName )
        if (policyId != ''):
                print "Found policy with name "+policyName+". Deleting..."
                AdminConfig.remove(policyId )
        #endIf 

        policyId = AdminConfig.create("OneOfNPolicy", coreGroup, [["name", policyName], ["description", policyName+" policy"], ["policyFactory", "com.ibm.ws.hamanager.coordinator.policy.impl.OneOfNPolicyFactory"], ["failback", "true"]] )

        AdminConfig.create("MatchCriteria", policyId, [["name", "WSAF_SIB_MESSAGING_ENGINE"], ["value", messagingEngineName]] )
        AdminConfig.create("MatchCriteria", policyId, [["name", "type"], ["value", "WSAF_SIB"]] )

        preferredServerList = []
        serverId = getCoreGroupServerId(coreGroup, nodeName, serverName )
        preferredServerList.append(serverId)
        AdminConfig.modify(policyId, [["preferredServers", serverId]] )
#endDef 

#
# Other functions
#

def createAuthDataEntry ( j2cAuthDataEntry, username, password ):
        global AdminConfig
        # remove existing entry if one exists
        for ac in AdminConfig.list("JAASAuthData" ).splitlines():
                if (AdminConfig.showAttribute(ac, "alias" ) == j2cAuthDataEntry):
                        AdminConfig.remove(ac )
                #endIf 
        #endFor 
        # create or recreate entry
        authEntry = AdminConfig.create("JAASAuthData", AdminConfig.list("Security" ), [["alias", j2cAuthDataEntry], ["userId", username], ["password", password]] )
        print "Created JAASAuthData "+j2cAuthDataEntry
        return authEntry
#endDef 
