#!/bin/sh

usage() {
  echo "Usage: redeploy-portal {-conntype <SOAP|RMI> -host <hostname> -port <port> -user <username> -password <password>}"
}

CONNTYPE=NONE
CONNTYPE_EXTRA=

while [ $# -gt 0 ]
do
  case "$1" in
    -conntype)
      CONNTYPE="$2"
      shift
      ;;
    -host)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -port)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -user)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -password)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    *)
      usage
      exit
  esac
  shift
done

TW_INSTALL_DIR=~DEPLOY_DIR~
. $TW_INSTALL_DIR/../bin/setEnv.sh

WAS_BIN_HOME=$APPSERVER_HOME/profiles/$WAS_PROFILE/bin
if [ "${TEAMWORKS_IS_ND:=}" = "true" ]
then
  WAS_BIN_HOME=$APPSERVER_HOME/profiles/$WAS_DMGR_PROFILE/bin
fi
TW_CLUSTER=${TEAMWORKS_PROCESS_SRV}_cluster
TW_VIRTUAL_HOST=~APPSERVER_VIRTUAL_HOST~

CLIENT_JAVA_HOME=~JVM~

if [ ! -d $CLIENT_JAVA_HOME ]; then
  echo "$CLIENT_JAVA_HOME is not correctly set. redeploy-portal requires a Java VM."
  exit 1
fi

if [ ! -f $CLIENT_JAVA_HOME/bin/jar ]; then
  echo "Jar could not be found in $CLIENT_JAVA_HOME/bin. redeploy-portal requires a Java VM."
  exit 1
fi

pushd
cd `dirname $0`
jar_cmd="$CLIENT_JAVA_HOME/bin/jar cvf ../applications/portal.war -C portal.war ."
eval $jar_cmd
popd

$WAS_BIN_HOME/wsadmin.sh -conntype $CONNTYPE $CONNTYPE_EXTRA -f $TW_INSTALL_DIR/portal-app/redeploy-portal.py $PROCESS_SRV_CELL $PROCESS_SRV_NODE $TEAMWORKS_PROCESS_SRV $TW_VIRTUAL_HOST $TW_INSTALL_DIR $TW_CLUSTER $TEAMWORKS_IS_ND

cp $TW_INSTALL_DIR/bin/was.policy $APPSERVER_HOME/profiles/$WAS_PROFILE/config/cells/$PROCESS_SRV_CELL/applications/portal.war.ear/deployments/portal.war/META-INF
